Index: trunk/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 888)
@@ -0,0 +1,147 @@
+MODULE sbcssm
+   !!======================================================================
+   !!                       ***  MODULE  sbcssm  ***
+   !! Surface module :  provide time-mean ocean surface variables
+   !!======================================================================
+   !! History :  9.0   !  06-07  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   sbc_ssm        : calculate sea surface mean currents, temperature,  
+   !!                    and salinity over nn_fsbc time-step
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE daymod          ! calendar
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE prtctl          ! Print control                    (prt_ctl routine)
+   USE restart         ! ocean restart
+   USE iom
+   USE in_out_manager  ! I/O manager
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   sbc_ssm    ! routine called by step.F90
+   
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE sbc_ssm( kt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE sbc_oce  ***
+      !!                     
+      !! ** Purpose :   provide ocean surface variable to sea-surface boundary
+      !!                condition computation 
+      !!                
+      !! ** Method  :   compute mean surface velocity (2 components at U and 
+      !!      V-points) [m/s], temperature [Celcius] and salinity [psu] over
+      !!      the periode (kt - nn_fsbc) to kt
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt        ! ocean time step
+      !
+      REAL(wp) ::   zcoef       ! temporary scalar
+      REAL(wp) ::   zf_sbc      ! read sbc frequency 
+      !!---------------------------------------------------------------------
+      !                                                   ! ---------------------------------------- !
+      IF( nn_fsbc == 1 ) THEN                             !      Instantaneous surface fields        !
+         !                                                ! ---------------------------------------- !
+         IF( kt == nit000 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'sbc_ssm : sea surface mean fields, nn_fsbc=1 : instantaneous values'
+            IF(lwp) WRITE(numout,*) '~~~~~~~ '
+         ENDIF
+         !
+         ssu_m(:,:) = un(:,:,1)
+         ssv_m(:,:) = vn(:,:,1)
+         sst_m(:,:) = tn(:,:,1)
+         sss_m(:,:) = sn(:,:,1)
+         !
+      ELSE
+         !                                                ! ---------------------------------------- !
+         IF( kt == nit000) THEN                           !       Initialisation: 1st time-step      !
+            !                                             ! ---------------------------------------- !
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'sbc_ssm : sea surface mean fields'
+            !
+            IF( ln_rstart .AND. iom_varid( numror, 'nn_fsbc' ) > 0 ) THEN 
+               CALL iom_get( numror             , 'nn_fsbc', zf_sbc )   ! sbc frequency of previous run
+               CALL iom_get( numror, jpdom_local, 'ssu_m'  , ssu_m  )   ! sea surface mean velocity    (T-point)
+               CALL iom_get( numror, jpdom_local, 'ssv_m'  , ssv_m  )   !   "         "    velocity    (V-point)
+               CALL iom_get( numror, jpdom_local, 'sst_m'  , sst_m  )   !   "         "    temperature (T-point)
+               CALL iom_get( numror, jpdom_local, 'sss_m'  , sss_m  )   !   "         "    salinity    (T-point)
+               !
+               IF( zf_sbc /= REAL( nn_fsbc, wp ) ) THEN      ! nn_fsbc has changed between 2 runs
+                  IF(lwp) WRITE(numout,*) '~~~~~~~   restart with a change in the frequency of mean ',   &
+                     &                    'from ', zf_sbc, ' to ', nn_fsbc
+                  zcoef = REAL( nn_fsbc - 1, wp ) / zf_sbc
+                  ssu_m(:,:) = zcoef * ssu_m(:,:)
+                  ssv_m(:,:) = zcoef * ssv_m(:,:)
+                  sst_m(:,:) = zcoef * sst_m(:,:)
+                  sss_m(:,:) = zcoef * sss_m(:,:)
+               ELSE
+                  IF(lwp) WRITE(numout,*) '~~~~~~~   mean fields read in the ocean restart file'
+               ENDIF
+            ELSE
+               IF(lwp) WRITE(numout,*) '~~~~~~~   mean fields initialised to instantaneous values'
+               zcoef = REAL( nn_fsbc - 1, wp )
+               ssu_m(:,:) = zcoef * un(:,:,1)
+               ssv_m(:,:) = zcoef * vn(:,:,1)
+               sst_m(:,:) = zcoef * tn(:,:,1)
+               sss_m(:,:) = zcoef * sn(:,:,1)
+            ENDIF
+            !                                             ! ---------------------------------------- !
+         ELSEIF( MOD( kt - 2 , nn_fsbc ) == 0 ) THEN      !   Initialisation: New mean computation   !
+            !                                             ! ---------------------------------------- !
+            ssu_m(:,:) = 0.e0      ! reset to zero ocean mean sbc fields
+            ssv_m(:,:) = 0.e0
+            sst_m(:,:) = 0.e0
+            sss_m(:,:) = 0.e0
+         ENDIF
+         !                                                ! ---------------------------------------- !
+         !                                                !        Cumulate at each time step        !
+         !                                                ! ---------------------------------------- !
+         ssu_m(:,:) = ssu_m(:,:) + un(:,:,1)
+         ssv_m(:,:) = ssv_m(:,:) + vn(:,:,1)
+         sst_m(:,:) = sst_m(:,:) + tn(:,:,1)
+         sss_m(:,:) = sss_m(:,:) + sn(:,:,1)
+
+         !                                                ! ---------------------------------------- !
+         IF( MOD( kt - 1 , nn_fsbc ) == 0 ) THEN          !   Mean value at each nn_fsbc time-step   !
+            !                                             ! ---------------------------------------- !
+            zcoef = 1. / REAL( nn_fsbc, wp )
+            sst_m(:,:) = sst_m(:,:) * zcoef           ! mean SST             [Celcius]
+            sss_m(:,:) = sss_m(:,:) * zcoef           ! mean SSS             [psu]
+            ssu_m(:,:) = ssu_m(:,:) * zcoef           ! mean suface current  [m/s]
+            ssv_m(:,:) = ssv_m(:,:) * zcoef           !
+            !
+         ENDIF
+         !                                                ! ---------------------------------------- !
+         IF( lrst_oce ) THEN                              !      Write in the ocean restart file     !
+            !                                             ! ---------------------------------------- !
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'sbc_ssm : sea surface mean fields written in ocean restart file ',   &
+               &                    'at it= ', kt,' date= ', ndastp
+            IF(lwp) WRITE(numout,*) '~~~~~~~'
+            zf_sbc = REAL( nn_fsbc, wp )
+            CALL iom_rstput( kt, nitrst, numrow, 'nn_fsbc', zf_sbc )    ! sbc frequency
+            CALL iom_rstput( kt, nitrst, numrow, 'ssu_m'  , ssu_m  )    ! sea surface mean fields
+            CALL iom_rstput( kt, nitrst, numrow, 'ssv_m'  , ssv_m  )
+            CALL iom_rstput( kt, nitrst, numrow, 'sst_m'  , sst_m  )
+            CALL iom_rstput( kt, nitrst, numrow, 'sss_m'  , sss_m  )
+            !
+         ENDIF
+         !
+      ENDIF
+      !
+   END SUBROUTINE sbc_ssm
+
+   !!======================================================================
+END MODULE sbcssm
Index: trunk/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 888)
@@ -0,0 +1,223 @@
+MODULE sbcssr
+   !!======================================================================
+   !!                       ***  MODULE  sbcssr  ***
+   !! Surface module :  add to heat and fresh water fluxes a restoring term
+   !!                   toward observed SST/SSS
+   !!======================================================================
+   !! History :  9.0   !  06-06  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   sbc_ssr        : add to sbc a restoring term toward SST/SSS climatology
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE sbc_oce         ! surface boundary condition
+   USE phycst          ! physical constants
+   USE daymod          ! calendar
+   USE ocfzpt          ! ocean freezing point
+   USE sbcrnf          ! surface boundary condition : runoffs
+   USE fldread         ! read input fields
+   USE iom             ! I/O manager
+   USE in_out_manager  ! I/O manager
+   USE lib_mpp         ! distribued memory computing library
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   sbc_ssr    ! routine called in sbcmod
+   
+   REAL(wp), ALLOCATABLE, DIMENSION(:)   ::   buffer   ! Temporary buffer for exchange
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_sst   ! structure of input SST (file informations, fields read)
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_sss   ! structure of input SSS (file informations, fields read)
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   erp       !: evaporation damping                          [kg/m2/s]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qrp       !: heat flux damping                            [w/m2]
+
+   !! * Namelist namsbc_ssr
+   INTEGER ::   nn_sstr, nn_sssr   ! SST/SSS indicator
+   REAL(wp) ::  dqdt   , deds      ! restoring term factor
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE sbc_ssr( kt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE sbc_ssr  ***
+      !!
+      !! ** Purpose :   Add to heat and/or freshwater fluxes a damping term
+      !!                toward observed SST and/or SSS.
+      !!
+      !! ** Method  : - Read namelist namsbc_ssr
+      !!              - Read observed SST and/or SSS
+      !!              - at each nscb time step
+      !!                   add a retroaction term on qns    (nn_sstr = 1)
+      !!                   add a damping term on emps       (nn_sssr = 1)
+      !!                   add a damping term on emp & emps (nn_sssr = 2)
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in   ) ::   kt   ! ocean time step
+      !!
+      INTEGER  ::   ji, jj   ! dummy loop indices
+      REAL(wp) ::   zerp     ! local scalar for evaporation damping
+      REAL(wp) ::   zqrp     ! local scalar for heat flux damping
+      REAL(wp) ::   zsrp     ! local scalar for unit conversion of deds factor
+      INTEGER  ::   ierror   ! return error code
+      !!
+      CHARACTER(len=100) ::  cn_dir          ! Root directory for location of ssr files
+      TYPE(FLD_N) ::   sn_sst, sn_sss        ! informations about the fields to be read
+      NAMELIST/namsbc_ssr/ cn_dir, nn_sstr, nn_sssr, dqdt, deds, sn_sst, sn_sss
+      !!----------------------------------------------------------------------
+      !                                               ! -------------------- !
+      IF( kt == nit000 ) THEN                         ! First call kt=nit000 !
+         !                                            ! -------------------- !
+         !                         ! set file information
+         nn_sstr = 0
+         nn_sssr = 0
+         dqdt = -40.e0
+         deds = -27.70
+         cn_dir = './'       ! directory in which the model is executed
+         ! ... default values (NB: frequency positive => hours, negative => months)
+         !            !   file    ! frequency !  variable  ! time intep !  clim  ! starting !
+         !            !   name    !  (hours)  !   name     !   (T/F)    !  (0/1) !  record  !
+         sn_sst = FLD_N( 'sst'     ,    24.    ,  'sst'     ,  .FALSE.   ,    0   ,     0    )
+         sn_sss = FLD_N( 'sss'     ,   -12.    ,  'sss'     ,  .TRUE.    ,    0   ,     0    )
+
+         REWIND ( numnam )         ! ... read in namlist namflx
+         READ( numnam, namsbc_ssr ) 
+
+         IF(lwp) THEN              ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) 'sbc_ssr : SST and/or SSS damping term '
+            WRITE(numout,*) '~~~~~~~ '
+            WRITE(numout,*) '          SST restoring term (Yes=1)             nn_sstr = ', nn_sstr
+            WRITE(numout,*) '          SSS damping term (Yes=1, salt flux)    nn_sssr = ', nn_sssr
+            WRITE(numout,*) '                           (Yes=2, volume flux) '
+            WRITE(numout,*) '          dQ/dT (restoring magnitude on SST)     dqdt    = ', dqdt, ' W/m2/K'
+            WRITE(numout,*) '          dE/dS (restoring magnitude on SST)     deds    = ', deds, ' mm/day'
+         ENDIF
+
+         IF( nn_sstr == 1 ) THEN      ! set sf_sst structure
+            !
+            ALLOCATE( sf_sst(1), STAT=ierror )
+            IF( ierror > 0 ) THEN
+               CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sst structure' )   ;   RETURN
+            ENDIF
+            ! namelist informations stored in sf_sst structures
+            WRITE( sf_sst(1)%clrootname, '(a,a)' )   TRIM( cn_dir ), TRIM( sn_sst%clname )
+            sf_sst(1)%freqh   = sn_sst%freqh
+            sf_sst(1)%clvar   = sn_sst%clvar 
+            sf_sst(1)%ln_tint = sn_sst%ln_tint
+            sf_sst(1)%nclim   = sn_sst%nclim  
+            sf_sst(1)%nstrec  = sn_sst%nstrec  
+            IF(lwp) THEN             ! control print
+               WRITE(numout,*) '   SST restoring term toward SST data in the following file: '
+               WRITE(numout,*) '               root filename: '  , trim( sf_sst(1)%clrootname ),   &
+                  &                          ' variable name: '  , trim( sf_sst(1)%clvar      )
+               WRITE(numout,*) '               frequency: '      ,       sf_sst(1)%freqh       ,   &
+                  &                          ' time interp: '    ,       sf_sst(1)%ln_tint     ,   &
+                  &                          ' climatology: '    ,       sf_sst(1)%nclim       ,   &
+                  &                          ' starting record: ',       sf_sst(1)%nstrec
+            ENDIF
+         ENDIF
+         !
+         IF( nn_sssr == 1 ) THEN      ! set sf_sss structure
+            !
+            ALLOCATE( sf_sss(1), STAT=ierror )
+            IF( ierror > 0 ) THEN
+               CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sss structure' )   ;   RETURN
+            ENDIF
+            ! namelist informations stored in sf_sss structures
+            WRITE( sf_sss(1)%clrootname, '(a,a)' )   TRIM( cn_dir ), TRIM( sn_sss%clname )
+            sf_sss(1)%freqh   = sn_sss%freqh
+            sf_sss(1)%clvar   = sn_sss%clvar
+            sf_sss(1)%ln_tint = sn_sss%ln_tint
+            sf_sss(1)%nclim   = sn_sss%nclim
+            sf_sss(1)%nstrec  = sn_sss%nstrec
+            IF(lwp) THEN             ! control print
+               WRITE(numout,*) '   SSS dampming  term toward SSS data in the following file: ' 
+               WRITE(numout,*) '               root filename: '  , trim( sf_sss(1)%clrootname ),   &
+                  &                          ' variable name: '  , trim( sf_sss(1)%clvar      )
+               WRITE(numout,*) '               frequency: '      ,       sf_sss(1)%freqh       ,   &
+                  &                          ' time interp: '    ,       sf_sss(1)%ln_tint     ,   &
+                  &                          ' climatology: '    ,       sf_sss(1)%nclim       ,   &
+                  &                          ' starting record: ',       sf_sss(1)%nstrec
+            ENDIF
+         ENDIF
+         !
+         ! Initialize qrp and erp if no restoring 
+         IF( nn_sstr /= 1                   )   qrp(:,:) = 0.e0 
+         IF( nn_sssr /= 1 .OR. nn_sssr /= 2 )   erp(:,:) = 0.e0 
+      ENDIF
+
+      IF( nn_sstr + nn_sssr /= 0 ) THEN
+
+         IF( nn_sstr == 1)   CALL fld_read( kt, nn_fsbc, sf_sst )   ! Read SST data and provides it
+         !                                                          ! at the current time-step
+         IF( nn_sssr == 1)   CALL fld_read( kt, nn_fsbc, sf_sss )   ! Read SSS data and provides it
+         !                                                          ! at the current time-step
+ 
+         !                                         ! ========================= !
+         IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN      !    Add restoring term     !
+            !                                      ! ========================= !
+            !
+            IF( nn_sstr == 1 ) THEN                   ! Temperature restoring term
+!CDIR COLLAPSE
+               ! use zqrp scalar to optimize memory access (speedup the loop)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     zqrp = dqdt * ( sst_m(ji,jj) - sf_sst(1)%fnow(ji,jj) )
+                     qns(ji,jj) = qns(ji,jj) + zqrp
+                     qrp(ji,jj) = zqrp
+                  END DO
+               END DO
+            ENDIF
+            !
+            IF( nn_sssr == 1 ) THEN                   ! Salinity damping term (salt flux, emps only)
+!CDIR COLLAPSE
+               ! use zerp scalar to optimize memory access (speedup the loop)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     zsrp = deds / rday                               ! from [mm/day] to [kg/m2/s]
+                     zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
+                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj) )   &
+                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                     emps(ji,jj) = emps(ji,jj) + zerp
+                     erp( ji,jj) = zerp
+                  END DO
+               END DO
+            ELSEIF( nn_sssr == 2 ) THEN               ! Salinity damping term (volume flux, emp and emps)
+!CDIR COLLAPSE
+               ! use zerp scalar to optimize memory access (speedup the loop)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi                            
+                     zsrp = deds / rday                               ! from [mm/day] to [kg/m2/s]
+                     zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
+                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj) )   &
+                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                     emp (ji,jj) = emp (ji,jj) + zerp
+                     emps(ji,jj) = emps(ji,jj) + zerp
+                     erp (ji,jj) = zerp
+                  END DO
+               END DO
+            ENDIF
+            !
+         ENDIF
+         !
+      ENDIF
+
+      !!gm ... to be written                     ! Output sbc fields (using IOM)
+      ! prevoir comment obtenir l info sst sss ssr
+      !
+   END SUBROUTINE sbc_ssr
+      
+   !!======================================================================
+END MODULE sbcssr
